<template>
  <div class="overflow-hidden rounded-lg">
    <el-carousel
      trigger="click"
      :interval="4000"
      arrow="always"
      height="150px"
      v-if="!bannerLoading"
    >
      <el-carousel-item v-for="item in themeBannerForDisplay" :key="item.Id">
        <nuxt-link :to="item.HyperLink">
          <img :src="item.ImagePath" class="mx-auto" />
        </nuxt-link>
      </el-carousel-item>
    </el-carousel>
  </div>
</template>
<script lang="ts">
import { computed, defineComponent, PropType, toRefs } from "vue";
import {
  IThemePropertiesFromApi,
  ThemePropertiesFromApiDto,
} from "@/models/companyThemePropertiesRespone";

const bannerKeys: Record<string, string> = {
  home: "lobby_banner_",
};

export default defineComponent({
  name: "MBanner",
  props: {
    themeProperties: {
      type: Array as PropType<Array<IThemePropertiesFromApi>>,
      required: true,
    },
    actived: {
      type: String,
      default: "home",
    },
  },
  setup(props) {
    const { themeProperties, actived } = toRefs(props);
    const bannerKey = bannerKeys[actived.value]
      ? bannerKeys[actived.value]
      : bannerKeys.home;
    const themeBannerForDisplay = computed(
      (): Array<ThemePropertiesFromApiDto> =>
        themePropertyHelper.getMultipleThemesProperties(
          themeProperties.value,
          bannerKey
        )
    );
    const bannerLoading = computed(
      () => themeBannerForDisplay.value.length === 0
    );
    return {
      themeBannerForDisplay,
      bannerLoading,
    };
  },
});
</script>

<style scoped>
.el-carousel {
  --el-carousel-indicator-width: 20px;
  --el-carousel-indicator-height: 2px;
}
</style>
